]>
git.saurik.com Git - apple/file_cmds.git/blob - gzip/gzexe
3 # $NetBSD: gzexe,v 1.3 2004/05/01 08:22:41 wiz Exp $
4 # $OpenBSD: gzexe,v 1.3 2003/08/05 18:22:17 deraadt Exp $
7 # Copyright (c) 2003 Otto Moerbeek <otto@drijf.net>
9 # Permission to use, copy, modify, and distribute this software for any
10 # purpose with or without fee is hereby granted, provided that the above
11 # copyright notice and this permission notice appear in all copies.
13 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
14 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
15 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
16 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
17 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
18 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
19 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
21 # $FreeBSD: src/usr.bin/gzip/gzexe,v 1.1 2007/01/26 10:19:07 delphij Exp $
23 # The number of lines plus one in the on-the-fly decompression script
26 # A simple string to recognize already compressed files
27 magic
="# compressed by gzexe"
29 # Write the decompression script to stdout
31 # first section needs variable expansion, second not
38 prog=`/usr/bin/basename "$0"`
39 tmp=`/usr/bin/mktemp -d /tmp/gzexeXXXXXXXXXX` || {
40 /bin/echo "$prog: cannot create tmp dir"; exit 1
42 trap '/bin/rm -rf "$tmp"' 0
43 if /usr/bin/tail +$lines "$0" |
44 /usr/bin/gzip -dc > "$tmp/$prog" 2> /dev/null; then
45 /bin/chmod u+x "$tmp/$prog"
46 "$tmp/$prog" ${1+"$@"}
49 /bin/echo "$prog: cannot decompress $0"
56 # Test if a file is compressed by checking the magic line
58 test "X`sed -n 2p "$1" 2> /dev/null`" = "X$magic"
63 tmp
=`mktemp /tmp/gzexeXXXXXXXXXX` || {
64 echo "$prog: cannot create tmp file"
67 if ! cp "$1" "$tmp"; then
68 echo "$prog: cannot copy $1 to $tmp"
72 if ! tail +$lines "$tmp" | gzip -vdc > "$1"; then
73 echo "$prog: cannot decompress $1"
80 # Perform some sanity checks on the file
82 if test ! -e "$1"; then
83 echo "$prog: cannot compress non-existing file $1"
87 if test ! -f "$1"; then
88 echo "$prog: cannot compress non-regular file $1"
92 case `basename "$1"` in
93 sh
| mktemp
| rm | echo | tail | gzip | chmod)
94 echo "$prog: cannot compress $1, I depend on it"
98 if test ! -x "$1"; then
99 echo "$prog: cannot compress $1, it is not executable"
103 if test -u "$1" -o -g "$1"; then
104 echo "$prog: cannot compress $1, it has an s bit set"
111 tmp
=`mktemp /tmp/gzexeXXXXXXXXXX` || {
112 echo "$prog: cannot create tmp file"
115 if ! cp "$1" "$tmp"; then
116 echo "$prog: cannot copy $1 to $tmp"
120 if ! cp "$1" "$1"~
; then
121 echo "$prog: cannot create backup copy $1~"
126 # Use cp to overwrite the existing file preserving mode and owner
127 # if possible. If the file is not writable, this will produce an
130 if header
"$1" > "$tmp" && gzip -vc "$1" >> "$tmp"; then
131 if ! cp "$tmp" "$1"; then
132 echo "$prog: cannot copy $tmp to $1"
137 echo "$prog: cannot compress $1"
143 # Is the -d flag specified?
149 if test "X$1" = X
-d; then
155 USAGE
="usage: $prog [-d] file ..."
156 if test $# -eq 0; then
161 while test $# -ne 0; do
163 if ! compressed
"$1"; then
164 echo "$prog: $1 is not compressed"
166 elif ! decompress
"$1"; then
170 if compressed
"$1"; then
171 echo "$prog: $1 is already compressed"
173 elif ! check
"$1" || ! compress "$1"; then